' Stymphalia Retro for BCC97 by count-doku

SuperStrict

Framework brl.blitz
Import brl.glmax2d
Import brl.random

Include "TGrass.bmx"
Include "TCloud.bmx"
Include "TBird.bmx"
Include "TPlayer.bmx"
Include "TArrow.bmx"

AppTitle = "Stymphalia Retro - BCC97"

SeedRnd MilliSecs()

Global PhysicalResX:Int = 1200, PhysicalResY:Int = 900, VirtualResX:Int = 400, VirtualResY:Int = 300

If (AppArgs.Length = 3) And (Int(AppArgs[1]) > 0) And (Int(AppArgs[2]) > 0)
	PhysicalResX = Int(AppArgs[1])
	PhysicalResY = Int(AppArgs[2])
End If

InitGraphics()
InitAll()

Local loopStart:Long, infoVis:Byte = True, lost:Byte = False, win:Byte = False

While(Not (AppTerminate() Or KeyHit(KEY_ESCAPE)))
	loopStart = MilliSecs()
	Cls

	If ((win Or lost) = False)
		TPlayer.Update()
	EndIf
	
	DrawBackground()
	TCloud.DrawAll()
		
	TGrass.DrawAll(-1)
	TPlayer.Draw()
	TGrass.DrawAll(1)
	
	TBird.RenderAll()
	TArrow.RenderAll()
	
	If (infoVis) Then DrawHelp()
	If (KeyHit(KEY_F1)) Then infoVis = Not infoVis;
	If (KeyHit(KEY_F2))
		infoVis = True
		lost = False
		win = False
		
		InitAll()
	EndIf
	
	If (TPlayer.points <= 0)
		lost = True
	End If
	If (TBird.list.Count() = 0)
		win = True
	End If
	
	
	If (win)
		SetColor(0, 255, 0)
		DrawText("You won with " + TPlayer.points + " points!  (F2 to reset)", 50, 110)
	End If
	If (lost)
		SetColor(255, 0, 0)
		DrawText("You lost!  (F2 to reset)", 100, 110)
	End If
		
	Delay(16 - (MilliSecs() - loopStart))
	Flip 0
Wend
End


Function InitAll()
	MouseHit(MOUSE_LEFT)
	MouseHit(MOUSE_RIGHT)

	TGrass.Init()
	TCloud.Init()
	TBird.Init()
	TPlayer.Init()
	TArrow.Init()

End Function
Function InitGraphics()
	SetGraphicsDriver GLMax2DDriver()
	Graphics(PhysicalResX, PhysicalResY, 0, 60, GRAPHICS_BACKBUFFER | GRAPHICS_ALPHABUFFER)
	SetBlend(ALPHABLEND)
	SetVirtualResolution(VirtualResX, VirtualResY)
End Function

Function DrawHelp()
	SetColor(255, 255, 255)
	Local x:Int = 30
	Local y:Int = 30
	Local line:Int = 14
	DrawText("Stymphalia Retro", x, y)
	DrawText("Kill the birds, while they are in the air!", x, y + line * 1)
	DrawText("Hitting a bird will yield 10 points,", x, y + line * 2)
	DrawText("shooting cost 1 point, scaring 20 points.", x, y + line * 3)
	
	DrawText("[Right Mouse] to scare the birds", x, y + line * 5)
	DrawText("[Left Mouse] to shoot an arrow", x, y + line * 6)
	DrawText("[W/A/S/D] to move around", x, y + line * 7)
	DrawText("[F1] show/hide this info", x, y + line * 8)
	DrawText("[F2] to reset", x, y + line * 9)
	DrawText("[Escape] will close the game", x, y + line * 10)
	DrawText("by count-doku", x, y + line * 18)
End Function


Function DrawBackground()
	color_swamp()
	DrawRect(0, 150, 400, 150)
	
	color_aqua()
	DrawRect(0, 100, 400, 50)
	
	color_sky()
	DrawRect(0, 0, 400, 100)
End Function

Function GetMX:Double()
	Return Double(MouseX()) * (Double(VirtualResX) / Double(PhysicalResX))
End Function
Function GetMY:Double()
	Return Double(MouseY()) * (Double(VirtualResY) / Double(PhysicalResY))
End Function

Function color_swamp()
	SetColor(0, 65, 0)
End Function
Function color_aqua()
	SetColor(65, 65, 255)
End Function
Function color_grass()
	SetColor(0, 150, 0)
End Function
Function color_bird()
	SetColor(139, 121, 094)
End Function
Function color_arrow()
	SetColor(200, 082, 045)
End Function
Function color_sky()
	SetColor(135, 206, 235)
End Function
Function color_cloud()
	SetColor(200, 200, 200)
End Function