Type TArrow
	Global list:TList
	
	Const ArrowSpeed:Float = 3
	
	Function Init()
		list = CreateList()
	End Function
	Function RenderAll()
		For Local arrow:TArrow = EachIn list
			arrow.Update()
			arrow.Draw()
		Next
	End Function
	
	
	'--------------------------------------------------------------
	
	Field x:Double
	Field y:Double
	Field angle:Double
	Field distance:Double
	
			
	Function Create(x:Double, y:Double, angle:Double)
		Local arrow:TArrow = New TArrow
		arrow.x = x
		arrow.y = y
		arrow.angle = angle
		
		
		list.AddFirst(arrow)
	End Function
		
	Method Update()
			x = x + (Sin(angle) * ArrowSpeed)
			y = y - (Cos(angle) * ArrowSpeed)
			
			If (y < 0) Or (y > 300)
				' Arrow hit nothing
				list.Remove(Self)
			End If
			If (x < 0)
				' Arrow hit nothing
				list.Remove(Self)
			End If
			If (x > 400)
				' Arrow hit nothing
				list.Remove(Self)
			End If
			
			For Local bird:TBird = EachIn TBird.list
				If Not bird.triggered Then Continue
				Local xdist:Double = (bird.x - x) * (bird.x - x)
				Local ydist:Double = (bird.y - y) * (bird.y - y)
				Local dist:Double = Sqr(xdist + ydist)
				If (dist < 6)
					' We hit a bird
					TPlayer.points:+10
					TBird.list.Remove(bird)
					list.Remove(Self)
				End If
			Next
			
	End Method
	
	Method Draw()
		color_arrow()
		SetLineWidth(3)
		DrawLine(x, y, x + Sin(angle) * 8, y - Cos(angle) * 8)
	End Method
End Type
